
#import "b4i_main.h"


@implementation b4i_main 


+ (instancetype)new {
    static b4i_main* shared = nil;
    if (shared == nil) {
        shared = [self alloc];
        shared.bi = [[B4IShellBI alloc] init:shared];
        shared.__c = [B4ICommon new];
    }
    return shared;
}
- (int)debugAppId {
    return 27;
}


- (NSString*)  _application_background{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"application_background"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"application_background" :nil]);
[B4IRDebugUtils shared].currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Private Sub Application_Background";
[B4IRDebugUtils shared].currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _application_start:(B4INavigationControllerWrapper*) _nav{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"application_start"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"application_start:" :@[[B4I nilToNSNull:_nav]]]);
int _i = 0;
[B4IRDebugUtils shared].currentLine=65536;
 //BA.debugLineNum = 65536;BA.debugLine="Private Sub Application_Start (Nav As NavigationCo";
[B4IRDebugUtils shared].currentLine=65537;
 //BA.debugLineNum = 65537;BA.debugLine="NavControl = Nav";
self._navcontrol = _nav;
[B4IRDebugUtils shared].currentLine=65538;
 //BA.debugLineNum = 65538;BA.debugLine="Page1.Initialize(\"Page1\")";
[self._page1 Initialize:self.bi :@"Page1"];
[B4IRDebugUtils shared].currentLine=65539;
 //BA.debugLineNum = 65539;BA.debugLine="Page1.RootPanel.LoadLayout(\"Main\")";
[[self._page1 RootPanel] LoadLayout:@"Main" :self.bi];
[B4IRDebugUtils shared].currentLine=65540;
 //BA.debugLineNum = 65540;BA.debugLine="NavControl.ShowPage(Page1)";
[self._navcontrol ShowPage:(UIViewController*)((self._page1).object)];
[B4IRDebugUtils shared].currentLine=65541;
 //BA.debugLineNum = 65541;BA.debugLine="myDictionary.Initialize(\"tv\", False)";
[self._mydictionary Initialize:self.bi :@"tv" :[self.__c False]];
[B4IRDebugUtils shared].currentLine=65542;
 //BA.debugLineNum = 65542;BA.debugLine="Page1.RootPanel.AddView(myDictionary, 0, 0, 100%x";
[[self._page1 RootPanel] AddView:(UIView*)((self._mydictionary).object) :(float) (0) :(float) (0) :[self.__c PerXToCurrent:(float) (100)] :[self.__c PerYToCurrent:(float) (100)]];
[B4IRDebugUtils shared].currentLine=65543;
 //BA.debugLineNum = 65543;BA.debugLine="myDictionary.RowHeight = 150 'must set RowHeight";
[self._mydictionary setRowHeight:(float) (150)];
[B4IRDebugUtils shared].currentLine=65544;
 //BA.debugLineNum = 65544;BA.debugLine="For i = 1 To 5";
{
const int step8 = 1;
const int limit8 = (int) (5);
_i = (int) (1) ;
for (;(step8 > 0 && _i <= limit8) || (step8 < 0 && _i >= limit8) ;_i = ((int)(0 + _i + step8))  ) {
[B4IRDebugUtils shared].currentLine=65545;
 //BA.debugLineNum = 65545;BA.debugLine="createNewEntryInMyDictionary";
[self _createnewentryinmydictionary];
 }
};
[B4IRDebugUtils shared].currentLine=65547;
 //BA.debugLineNum = 65547;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _createnewentryinmydictionary{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"createnewentryinmydictionary"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"createnewentryinmydictionary" :nil]);
B4ITableCell* _tc = nil;
[B4IRDebugUtils shared].currentLine=3342336;
 //BA.debugLineNum = 3342336;BA.debugLine="private Sub createNewEntryInMyDictionary";
[B4IRDebugUtils shared].currentLine=3342338;
 //BA.debugLineNum = 3342338;BA.debugLine="Dim tc As TableCell = myDictionary.AddSingleLine(";
_tc = [self._mydictionary AddSingleLine:@""];
[B4IRDebugUtils shared].currentLine=3342340;
 //BA.debugLineNum = 3342340;BA.debugLine="tc.ShowSelection = False";
[_tc setShowSelection:[self.__c False]];
[B4IRDebugUtils shared].currentLine=3342341;
 //BA.debugLineNum = 3342341;BA.debugLine="tc.CustomView = CreateItem";
[_tc setCustomView:[self _createitem]];
[B4IRDebugUtils shared].currentLine=3342343;
 //BA.debugLineNum = 3342343;BA.debugLine="tc.CustomView.Tag = tc";
[[_tc CustomView] setTag:(NSObject*)(_tc)];
[B4IRDebugUtils shared].currentLine=3342345;
 //BA.debugLineNum = 3342345;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _btnclearmydictionary_click{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"btnclearmydictionary_click"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"btnclearmydictionary_click" :nil]);
[B4IRDebugUtils shared].currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub btnClearMyDictionary_Click";
[B4IRDebugUtils shared].currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="myDictionary.Clear";
[self._mydictionary Clear];
[B4IRDebugUtils shared].currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _btnnewmydictionary_click{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"btnnewmydictionary_click"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"btnnewmydictionary_click" :nil]);
[B4IRDebugUtils shared].currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub btnNewMyDictionary_Click";
[B4IRDebugUtils shared].currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="myDictionary.RowHeight = 150";
[self._mydictionary setRowHeight:(float) (150)];
[B4IRDebugUtils shared].currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="createNewEntryInMyDictionary";
[self _createnewentryinmydictionary];
[B4IRDebugUtils shared].currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="myDictionary.ReloadAll";
[self._mydictionary ReloadAll];
[B4IRDebugUtils shared].currentLine=720901;
 //BA.debugLineNum = 720901;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _btnsavemydictionary_click{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"btnsavemydictionary_click"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"btnsavemydictionary_click" :nil]);
B4IList* _mydictionarylist = nil;
B4ITableCell* _tc = nil;
B4IPanelWrapper* _parent = nil;
B4ITextFieldWrapper* _question = nil;
B4ITextFieldWrapper* _answer = nil;
[B4IRDebugUtils shared].currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub btnSaveMyDictionary_Click";
[B4IRDebugUtils shared].currentLine=851971;
 //BA.debugLineNum = 851971;BA.debugLine="Dim myDictionaryList As List";
_mydictionarylist = [B4IList new];
[B4IRDebugUtils shared].currentLine=851972;
 //BA.debugLineNum = 851972;BA.debugLine="myDictionaryList.Initialize";
[_mydictionarylist Initialize];
[B4IRDebugUtils shared].currentLine=851975;
 //BA.debugLineNum = 851975;BA.debugLine="For Each tc As TableCell In myDictionary.GetItem";
{
const id<B4IIterable> group3 = [self._mydictionary GetItems:(int) (0)];
const int groupLen3 = group3.Size
;int index3 = 0;
;
for (; index3 < groupLen3;index3++){
_tc = (B4ITableCell*)([group3 Get:index3]);
[B4IRDebugUtils shared].currentLine=851976;
 //BA.debugLineNum = 851976;BA.debugLine="Dim parent As Panel = tc.CustomView";
_parent = [B4IPanelWrapper new];
_parent = [_tc CustomView];
[B4IRDebugUtils shared].currentLine=851977;
 //BA.debugLineNum = 851977;BA.debugLine="Dim question As TextField = parent.GetView(1) '";
_question = [B4ITextFieldWrapper new];
_question.object = (UITextField*)(([_parent GetView:(int) (1)]).object);
[B4IRDebugUtils shared].currentLine=851978;
 //BA.debugLineNum = 851978;BA.debugLine="Dim answer As TextField = parent.GetView(3) 'th";
_answer = [B4ITextFieldWrapper new];
_answer.object = (UITextField*)(([_parent GetView:(int) (3)]).object);
[B4IRDebugUtils shared].currentLine=851979;
 //BA.debugLineNum = 851979;BA.debugLine="Msgbox(\"Question = \" & question.text, \"Answer =";
[self.__c Msgbox:[@[@"Question = ",[_question Text]] componentsJoinedByString:@""] :[@[@"Answer = ",[_answer Text]] componentsJoinedByString:@""]];
 }
};
[B4IRDebugUtils shared].currentLine=851985;
 //BA.debugLineNum = 851985;BA.debugLine="End Sub";
return @"";
}
- (B4IPanelWrapper*)  _createitem{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"createitem"])
	return ((B4IPanelWrapper*) [B4IDebug delegate:self.bi :@"createitem" :nil]);
B4IPanelWrapper* _p = nil;
[B4IRDebugUtils shared].currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Private Sub CreateItem As Panel";
[B4IRDebugUtils shared].currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Dim p As Panel";
_p = [B4IPanelWrapper new];
[B4IRDebugUtils shared].currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="p.Initialize(\"\")";
[_p Initialize:self.bi :@""];
[B4IRDebugUtils shared].currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="p.Width = 100%x";
[_p setWidth:[self.__c PerXToCurrent:(float) (100)]];
[B4IRDebugUtils shared].currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="p.Height = myDictionary.RowHeight";
[_p setHeight:[self._mydictionary RowHeight]];
[B4IRDebugUtils shared].currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="p.LoadLayout(\"1\")";
[_p LoadLayout:@"1" :self.bi];
[B4IRDebugUtils shared].currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="Return p";
if (true) return _p;
[B4IRDebugUtils shared].currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _lbl_deleteentryfrommydictionary_click{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"lbl_deleteentryfrommydictionary_click"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"lbl_deleteentryfrommydictionary_click" :nil]);
B4ILabelWrapper* _lbl = nil;
B4INativeObject* _no = nil;
B4IPanelWrapper* _parent = nil;
B4ITextFieldWrapper* _question = nil;
B4ITextFieldWrapper* _answer = nil;
int _index = 0;
[B4IRDebugUtils shared].currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub lbl_deleteEntryFromMyDictionary_Click";
[B4IRDebugUtils shared].currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="Dim lbl As Label = Sender";
_lbl = [B4ILabelWrapper new];
_lbl.object = (UILabel*)([self.__c Sender:self.bi]);
[B4IRDebugUtils shared].currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="Dim no As NativeObject = lbl";
_no = [B4INativeObject new];
_no.object = (NSObject*)((_lbl).object);
[B4IRDebugUtils shared].currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="Dim Parent As Panel = no.GetField(\"superview\") 'g";
_parent = [B4IPanelWrapper new];
_parent.object = (B4IPanelView*)(([_no GetField:@"superview"]).object);
[B4IRDebugUtils shared].currentLine=917509;
 //BA.debugLineNum = 917509;BA.debugLine="Dim question As TextField = Parent.GetView(1) 'th";
_question = [B4ITextFieldWrapper new];
_question.object = (UITextField*)(([_parent GetView:(int) (1)]).object);
[B4IRDebugUtils shared].currentLine=917510;
 //BA.debugLineNum = 917510;BA.debugLine="Dim answer As TextField = Parent.GetView(3) 'this";
_answer = [B4ITextFieldWrapper new];
_answer.object = (UITextField*)(([_parent GetView:(int) (3)]).object);
[B4IRDebugUtils shared].currentLine=917513;
 //BA.debugLineNum = 917513;BA.debugLine="Dim index As Int = myDictionary.GetItems(0).Index";
_index = [[self._mydictionary GetItems:(int) (0)] IndexOf:[_parent Tag]];
[B4IRDebugUtils shared].currentLine=917514;
 //BA.debugLineNum = 917514;BA.debugLine="myDictionary.RemoveCells(0, index ,1)";
[self._mydictionary RemoveCells:(int) (0) :_index :(int) (1)];
[B4IRDebugUtils shared].currentLine=917515;
 //BA.debugLineNum = 917515;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _page1_barbuttonclick:(NSString*) _tag{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"page1_barbuttonclick"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"page1_barbuttonclick:" :@[[B4I nilToNSNull:_tag]]]);
[B4IRDebugUtils shared].currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Page1_BarButtonClick (Tag As String)";
[B4IRDebugUtils shared].currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="If Tag = \"back\" Then";
if ([_tag isEqual:@"back"]) { 
[B4IRDebugUtils shared].currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="Msgbox(\"return to previous page\",\"return back\")";
[self.__c Msgbox:@"return to previous page" :@"return back"];
 };
[B4IRDebugUtils shared].currentLine=327692;
 //BA.debugLineNum = 327692;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _page1_resize:(int) _width :(int) _height{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"page1_resize"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"page1_resize::" :@[@(_width),@(_height)]]);
[B4IRDebugUtils shared].currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Private Sub Page1_Resize(Width As Int, Height As I";
[B4IRDebugUtils shared].currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="refreshMyDictionaryTableview";
[self _refreshmydictionarytableview];
[B4IRDebugUtils shared].currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _refreshmydictionarytableview{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"refreshmydictionarytableview"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"refreshmydictionarytableview" :nil]);
B4ITableCell* _tc = nil;
[B4IRDebugUtils shared].currentLine=5308416;
 //BA.debugLineNum = 5308416;BA.debugLine="private Sub refreshMyDictionaryTableview";
[B4IRDebugUtils shared].currentLine=5308417;
 //BA.debugLineNum = 5308417;BA.debugLine="myDictionary.SetLayoutAnimated(400, 0.5, 0, 0, 10";
[self._mydictionary SetLayoutAnimated:(int) (400) :(float) (0.5) :(float) (0) :(float) (0) :[self.__c PerXToCurrent:(float) (100)] :[self.__c PerYToCurrent:(float) (90)]];
[B4IRDebugUtils shared].currentLine=5308418;
 //BA.debugLineNum = 5308418;BA.debugLine="For Each tc As TableCell In myDictionary.GetItems";
{
const id<B4IIterable> group2 = [self._mydictionary GetItems:(int) (0)];
const int groupLen2 = group2.Size
;int index2 = 0;
;
for (; index2 < groupLen2;index2++){
_tc = (B4ITableCell*)([group2 Get:index2]);
[B4IRDebugUtils shared].currentLine=5308419;
 //BA.debugLineNum = 5308419;BA.debugLine="tc.CustomView.Width = 100%x";
[[_tc CustomView] setWidth:[self.__c PerXToCurrent:(float) (100)]];
 }
};
[B4IRDebugUtils shared].currentLine=5308421;
 //BA.debugLineNum = 5308421;BA.debugLine="End Sub";
return @"";
}

- (void)initializeStaticModules {
    [[b4i_main new]initializeModule];

}
- (NSString*)  _process_globals{
[B4IRDebugUtils shared].currentModule=@"main";
if ([B4IDebug shouldDelegate: @"process_globals"])
	return ((NSString*) [B4IDebug delegate:self.bi :@"process_globals" :nil]);
[B4IRDebugUtils shared].currentLine=0;
 //BA.debugLineNum = 0;BA.debugLine="Sub Process_Globals";
[B4IRDebugUtils shared].currentLine=1;
 //BA.debugLineNum = 1;BA.debugLine="Public App As Application";
self._app = [B4IApplicationWrapper new];
[B4IRDebugUtils shared].currentLine=2;
 //BA.debugLineNum = 2;BA.debugLine="Public NavControl As NavigationController";
self._navcontrol = [B4INavigationControllerWrapper new];
[B4IRDebugUtils shared].currentLine=3;
 //BA.debugLineNum = 3;BA.debugLine="Private Page1 As Page";
self._page1 = [B4IPage new];
[B4IRDebugUtils shared].currentLine=4;
 //BA.debugLineNum = 4;BA.debugLine="Private myDictionary As TableView";
self._mydictionary = [B4ITableView new];
[B4IRDebugUtils shared].currentLine=5;
 //BA.debugLineNum = 5;BA.debugLine="End Sub";
return @"";
}
@end